## dune-uggrid 2.5.0

=== parallel/CMakeLists.txt ===
if(MPI_C_FOUND)
  # we need to deactivate the MPI C++ bindings
  # Maybe dune-common should export them?
  add_definitions(-DENABLE_MPI=1 -DMPICH_SKIP_MPICXX -DMPIPP_H)
  include_directories("$MPI_DUNE_INCLUDE_PATH")
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS ${MPI_DUNE_COMPILE_FLAGS})
 ug_add_dim_libs(parallel OBJECT initparallel.cc) # OBJECT_DIM_LIBS ddd dddif)
endif()

add_subdirectory(dddif)
add_subdirectory(ddd)
add_subdirectory(util)
add_subdirectory(ppif)

=== debian/changelog ===
dune-uggrid (2.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 18 Dec 2016 16:09:47 +0100

dune-uggrid (2.5.0~rc2-1) unstable; urgency=medium

  * Upload to unstable.
  * New upstream release candidate.
  * Override lintian warnings:
    - package-name-doesnt-match-sonames
    - non-dev-pkg-with-shlib-symlink
    - no-symbols-control-file

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 06 Dec 2016 00:56:05 +0100

dune-uggrid (2.5.0~rc1-2) experimental; urgency=medium

  * Install /usr/share/dune and /usr/share/dune-uggrid.

 -- Ansgar Burchardt <ansgar@debian.org>  Thu, 01 Dec 2016 18:18:48 +0100

dune-uggrid (2.5.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * Package the dune-uggrid module: We are only interested in the UG grid
    manager for DUNE. The old UG library will no longer be maintained in
    the future.
  * Bumped Standards-Version to 3.9.8 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 21 Nov 2016 20:53:47 +0100

ug (3.12.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 13 Sep 2015 13:21:24 +0200

ug (3.12.1-1) experimental; urgency=medium

  * New upstream release.
  * Change shared library package name to libug3.12.1.
  * Mention that UG has been built with support for DUNE in the
    package description.
  * Bump Standards-Version to 3.9.6 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 11 May 2015 21:05:04 +0200

ug (3.11.0-1) unstable; urgency=medium

  * New upstream release.
  * Change shared library package name to libug3.11.0.

 -- Ansgar Burchardt <ansgar@debian.org>  Sun, 15 Jun 2014 11:12:53 +0200

ug (3.10.0-1) unstable; urgency=low

  * Initial release. (Closes: #742179)

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 08 Apr 2014 02:07:52 +0200

=== debian/control ===
Source: dune-uggrid
Section: libs
Priority: optional
Standards-Version: 3.9.8
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-uggrid.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-uggrid.git
Homepage: https://gitlab.dune-project.org/staging/dune-uggrid/
Build-Depends: debhelper (>= 9),
 cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
 libdune-common-dev (>= 2.5.0)

Package: libdune-uggrid-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
 libdune-common-dev (>= 2.5.0)
Provides: ${dune:shared-library}
Suggests: libdune-uggrid-dbg (= ${binary:Version})
Conflicts: libug-dev
Replaces: libug-dev
Description: software framework for finite element methods (development files)
 UG is a flexible software tool for the numerical solution of partial
 differential equations on unstructured meshes, with a focus on
 multigrid methods. It has a very powerful grid manager, which supports
 two- and three-dimensional grids with mixed element types. The grids
 can be adaptively refinement using either classic
 red/green-refinement, or pure red refinement with hanging nodes. All
 this is fully parallelized and can run on large distributed machines.
 .
 The version in this package has been built with the necessary flags for use
 with the Dune software system.
 .
 This package contains the development files.

Package: libdune-uggrid-dbg
Section: debug
Priority: extra
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libdune-uggrid-dev (= ${binary:Version})
Description: software framework for finite element methods (debug symbols)
 UG is a flexible software tool for the numerical solution of partial
 differential equations on unstructured meshes, with a focus on
 multigrid methods. It has a very powerful grid manager, which supports
 two- and three-dimensional grids with mixed element types. The grids
 can be adaptively refinement using either classic
 red/green-refinement, or pure red refinement with hanging nodes. All
 this is fully parallelized and can run on large distributed machines.
 .
 The version in this package has been built with the necessary flags for use
 with the Dune software system.
 .
 This package contains the debug symbols.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk

%:
	dh $@ --parallel --builddirectory=build

override_dh_strip:
	dh_strip --dbg-package=libdune-uggrid-dbg

## dune-uggrid 2.5.1

=== CMakeLists.txt ===
# set up project
project("dune-uggrid" C CXX)

#circumvent not building docs
set(BUILD_DOCS 1)

# general stuff
cmake_minimum_required(VERSION 2.8.12)

#find dune-common and set the module path
find_package(dune-common)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
     "${CMAKE_SOURCE_DIR}/cmake/modules")# make sure our own modules are found

#include the dune macros
include(DuneMacros)

# start a dune project with information from dune.module
dune_project()

find_package(MPI)
# set defines that are only used internally.
# The rest is in cmake/modules/DuneUggrid.cmake
if(MPI_C_FOUND)
  set(UG_ENABLE_PARALLEL True CACHE BOOL "Enable a parallel UG (default is True if MPI is there false otherwise")
else()
  set(UG_ENABLE_PARALLEL False CACHE BOOL "Enable a parallel UG (default is True if MPI is there false otherwise")
endif()

set(UG_ENABLE_DEBUGGING False CACHE BOOL "Enable UG debugging (default is Off)")
set(UG_ENABLE_2D True CACHE BOOL "Build library for 2d (default is On)")
set(UG_ENABLE_3D True CACHE BOOL "Build library for 3d (default is On)")
set(UG_ENABLE_SYSTEM_HEAP ON CACHE BOOL "If ON/True then we are using the operating system heap instead of the one internal to UG (Default: ON")
set(UG_DDD_MAX_MACROBITS "24" CACHE STRING
  "Set number of bits of an unsigned int used to store the process number,
       the remaining bits are used to store the local entity id")
if(UG_ENABLE_SYSTEM_HEAP)
  add_definitions("-DUG_USE_SYSTEM_HEAP=1")
  set(UG_EXTRAFLAGS "-DUG_USE_SYSTEM_HEAP=1")
endif()
if(UG_ENABLE_DEBUGGING)
  add_definitions("-DDebug")
  set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DDebug")
endif()

add_definitions(-DUGLIB -DFOR_DUNE)
set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DUGLIB -DFOR_DUNE")

#Always build parallel libs if MPI is found
if(UG_ENABLE_PARALLEL)
  if(NOT MPI_C_FOUND)
    message(SEND_ERROR "A parallel UG was requested but MPI was not found. Either change variable UG_ENABLE_PARALLEL or install MPI." )
  endif()
  add_definitions("-DModelP")
  set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DModelP")
endif()

#set the include headers
include_directories(${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/low
  ${PROJECT_SOURCE_DIR}/gm ${PROJECT_SOURCE_DIR}/dev ${PROJECT_SOURCE_DIR}/dom
  ${PROJECT_SOURCE_DIR}/np ${PROJECT_SOURCE_DIR}/ui
  ${PROJECT_SOURCE_DIR}/np/algebra
  ${PROJECT_SOURCE_DIR}/np/udm
  ${PROJECT_SOURCE_DIR}/parallel ${PROJECT_SOURCE_DIR}/parallel/ddd
  ${PROJECT_SOURCE_DIR}/parallel/ppif
  ${PROJECT_SOURCE_DIR}/parallel/dddif ${PROJECT_SOURCE_DIR}/parallel/util
  ${PROJECT_SOURCE_DIR}/parallel/ddd/include )


set(UG_ENABLED_DIMENSIONS)
if(UG_ENABLE_2D)
  list(APPEND UG_ENABLED_DIMENSIONS "2")
endif()

if(UG_ENABLE_3D)
  list(APPEND UG_ENABLED_DIMENSIONS "3")
endif()

macro(ug_expand_object_libs var dim)
  set(${var})
  foreach(_lib ${ARGN})
    set(${var} ${${var}} "\$<TARGET_OBJECTS:${_lib}${dim}>")
  endforeach()
endmacro()

# a macro that creates the libraries for all dimensions.
#
macro(ug_add_dim_libs LIB_NAME)
  cmake_parse_arguments(ADD_LIB  "OBJECT;DUNE" ""
    "SOURCES;SOURCES_2D;SOURCES_3D;OBJECT_LIBS;OBJECT_DIM_LIBS;ADD_LIBS" ${ARGN})
  if(ADD_LIB_APPEND)
    set(_append "APPEND") # append all libraries in export.
  endif()
  if(ADD_LIB_OBJECT)
    set(OBJECT "OBJECT")
  endif()

  ug_expand_object_libs(OBJECT_LIBS "" ${ADD_LIB_OBJECT_LIBS})
  foreach(dim  ${UG_ENABLED_DIMENSIONS})
    ug_expand_object_libs(OBJECT_DIM_LIBS ${dim} ${ADD_LIB_OBJECT_DIM_LIBS})

    if(ADD_LIB_DUNE)
      if(ADD_LIB_ADD_LIBS)
        set(_EXTRA_ARGS "ADD_LIBS" ${ADD_LIB_ADD_LIBS})
      endif()
      if(OBJECT)
        message(FATAL_ERROR "OBJECT may only be used in conjuction with DUNE property")
      endif()
      dune_add_library("${LIB_NAME}${dim}" ${OBJECT} ${ADD_LIB_SOURCES}
        ${ADD_LIB_SOURCES_${dim}D}
        ${ADD_LIB_UNPARSED_ARGUMENTS} ${OBJECT_DIM_LIBS} ${OBJECT_LIBS}
        ${_EXTRA_ARGS} ${_append})
      set(_libs "${LIB_NAME}${dim}")
      if(DUNE_BUILD_BOTH_LIBS)
        set(_libs ${_libs} "${LIB_NAME}${dim}-shared")
      endif()
    else()
      add_library("${LIB_NAME}${dim}" ${OBJECT} ${ADD_LIB_SOURCES}
        ${ADD_LIB_SOURCES_${dim}D}
        ${ADD_LIB_UNPARSED_ARGUMENTS} ${OBJECT_DIM_LIBS} ${OBJECT_LIBS})
      if(OBJECT AND DUNE_BUILD_BOTH_LIBS)
        set_property(TARGET "${LIB_NAME}${dim}" PROPERTY POSITION_INDEPENDENT_CODE TRUE)
      endif()
      if(ADD_LIB_ADD_LIBS)
        dune_target_link_libraries(${LIB_NAME}${dim} ${ADD_LIB_ADD_LIBS})
      endif()
      set(_libs "${LIB_NAME}${dim}")
    endif()
    foreach(_lib ${_libs})
      target_compile_definitions("${_lib}" PRIVATE "-DUG_DIM_${dim}")
    endforeach()
    set(_append "APPEND") # Do not overwrite but append next lib in export
  endforeach()
endmacro()
# !!! maybe make this configurable later
set(DYNAMIC_MEMORY_ALLOCMODEL True)

check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(time.h HAVE_TIME_H)

if(HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set(TIME_WITH_SYS_TIME True)
endif()

# do everything in the subdirs (order matters because of library dependencies!)
if(UG_ENABLE_PARALLEL)
  set(SUBDIRS  parallel)
else()
  set(SUBDIRS "")
endif()
set(SUBDIRS  ${SUBDIRS} low dev gm dom np ui lib)
set(CMAKE_INSTALL_PKGINCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/ug")

# create and install pkg-config information and
# cmake package configuration as ug not dune-uggrid
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
if(UG_ENABLE_PARALLEL)
  set(parallel "yes")
else()
  set(parallel "no")
endif()
set(fordune "yes")
set(VERSION ${DUNE_UGGRID_VERSION})
configure_file(libug.pc.in libug.pc)
configure_file(ug-config.cmake.in ug-config.cmake @ONLY)
configure_file(ug-config-version.cmake.in ug-config-version.cmake @ONLY)

#install header
install(FILES initug.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})
foreach(i ${SUBDIRS})
  add_subdirectory(${i})
endforeach(i ${SUBDIRS})

add_subdirectory(cmake/modules)
# set variable names for config.h
set(DDD_MAX_PROCBITS_IN_GID ${UG_DDD_MACROBITS})
# finalize the dune project, e.g., generate config.h etc.
# Use package init to set additional information
set(dune-uggrid_INIT "set(UG_PARALLEL ${parallel})
set(UG_FOR_DUNE yes)")

finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

# This comes after finalize as it uses DUNE_INSTALL_LIBDIR
# computed there.
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libug.pc
  DESTINATION ${DUNE_INSTALL_LIBDIR}/pkgconfig)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ug-config.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/ug-config-version.cmake
  DESTINATION ${DUNE_INSTALL_LIBDIR}/cmake/ug)

=== gm/CMakeLists.txt ===
set(SOURCES  algebra.cc enrol.cc evm.cc mgio.cc
  ugio.cc ugm.cc cw.cc initgm.cc elements.cc
  shapes.cc evalproc.cc rm.cc refine.cc smooth.cc
  dlmgr.cc gmcheck.cc er.cc mgheapmgr.cc)
# put this "template" into distribution-tarball as well
set(EXTRA_DIST  dlmgr.t)
set(gminclude_HEADERS  cw.h elements.h gm.h pargm.h evm.h
  shapes.h ugm.h dlmgr.h algebra.h rm.h refine.h)

ug_add_dim_libs(ug_gm OBJECT SOURCES ${SOURCES})# OBJECT_DIM_LIBS gg)

install(FILES ${gminclude_HEADERS} DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== lib/CMakeLists.txt ===
add_subdirectory(ugdata)

if(UG_ENABLE_PARALLEL)
  set(_parallel_dim_libs parallel ddd analyser basic ctrl ident if join mgr prio xfer dddif)
  set(_parallel_libs ppifmpi parutil)
endif()

set(_dim_libs ug_gm np algebra udm ugui low)

ug_add_dim_libs(ugL SOURCES ../initug.cc OBJECT_DIM_LIBS ${_dim_libs} OBJECT_LIBS  devices low)
ug_add_dim_libs(ugS APPEND DUNE SOURCES ../initug.cc
  OBJECT_DIM_LIBS ${_dim_libs} domS ${_parallel_dim_libs}
  OBJECT_LIBS devices low ${_parallel_libs})

if(MPI_C_FOUND)
  add_dune_mpi_flags(ugS2 ugS3)
endif()


install(TARGETS ugL2 ugL3 DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== low/CMakeLists.txt ===
add_subdirectory(test)

# normal headers
set(lowinclude_HEADERS  heaps.h ugenv.h ugstruct.h misc.h debug.h ugtypes.h
  general.h dimension.h boxtree.h ugtimer.h scan.h
  defaults.h fileopen.h namespace.h)

# special library for the parts of low that need a dimension
set(DIMDEPSOURCES  boxtree.cc)

# dimension-independent lib
add_library(low OBJECT ugenv.cc heaps.cc fifo.cc misc.cc defaults.cc initlow.cc
  fileopen.cc ugstruct.cc debug.cc bio.cc scan.cc ugtimer.cc)

if(DUNE_BUILD_BOTH_LIBS)
  # For shared libraries we need position independent code
  set_property(TARGET low PROPERTY POSITION_INDEPENDENT_CODE TRUE)
endif()
# dimension-dependent libs (2D 3D)
ug_add_dim_libs(low OBJECT SOURCES ${DIMDEPSOURCES} )

install(FILES ${lowinclude_HEADERS} DESTINATION  ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== np/CMakeLists.txt ===
set(SOURCES  initnp.cc)# initnp.h initnumerics.h np.h)

add_subdirectory(algebra)
add_subdirectory(udm)

ug_add_dim_libs(np OBJECT SOURCES ${SOURCES})
#  OBJECT_DIM_LIBS algebra amg field procs udm)

install(FILES np.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== parallel/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
   # we need to deactivate the MPI C++ bindings
   # Maybe dune-common should export them?
   add_definitions(-DENABLE_MPI=1 -DMPICH_SKIP_MPICXX -DMPIPP_H)
-  include_directories("$MPI_DUNE_INCLUDE_PATH")
+  include_directories("${MPI_DUNE_INCLUDE_PATH}")
   set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS ${MPI_DUNE_COMPILE_FLAGS})
  ug_add_dim_libs(parallel OBJECT initparallel.cc) # OBJECT_DIM_LIBS ddd dddif)
 endif()

=== ui/CMakeLists.txt ===
set(SOURCES initui.cc cmdline.cc
  commands.cc
)
install(FILES cmdint.h cmdline.h commands.h
  DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})
ug_add_dim_libs(ugui OBJECT SOURCES ${SOURCES})

=== dom/std/CMakeLists.txt ===
set(SOURCES  std_domain.cc std_parallel.cc) # std_domain.h std_internal.h)
ug_add_dim_libs(domS OBJECT SOURCES ${SOURCES} SOURCES_2D domains2d.cc
  SOURCES_3D domains3d.cc)
install(FILES std_domain.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== lib/ugdata/CMakeLists.txt ===
# install into share-directory
set(dist_data_DATA  helpfile.list RefRules.data tetra.rls triangle.rls)
install(FILES ${dist_data_DATA} DESTINATION ${CMAKE_INSTALL_DATADIR})

=== low/test/CMakeLists.txt ===
dune_add_test(SOURCES test-fifo.cc)
target_link_libraries(test-fifo ugL2)

=== np/algebra/CMakeLists.txt ===
set(SOURCES
  ugblas.cc
  ugiter.cc
  transgrid.cc
  block.cc
  npcheck.cc
  sm.cc
  blasm.cc
)

set(npinclude_HEADERS
  block.h
  sm.h)

ug_add_dim_libs(algebra OBJECT SOURCES ${SOURCES})

install(FILES ${npinclude_HEADERS} DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== parallel/dddif/CMakeLists.txt ===
set(SOURCES  initddd.cc memmgr.cc handler.cc lb.cc debugger.cc lbrcb.cc
  gridcons.cc support.cc identify.cc identify.h trans.cc priority.cc
  pgmcheck.cc overlap.cc partition.cc)

install(FILES parallel.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

if(MPI_C_FOUND)
  include_directories(${PROJECT_SOURCE_DIR}/parallel/ddd/include)
  ug_add_dim_libs(dddif OBJECT SOURCES ${SOURCES})
endif()

=== debian/changelog ===
dune-uggrid (2.5.1-2) unstable; urgency=medium

  * parallel/CMakeLists.txt: use `COMPILE_OPTIONS` instead of
    `COMPILE_DEFINITIONS`.  Fixes build failure with cmake 3.10.
    (Closes: #891151)
    + patch: 0001-cmake-Fix-compatibility-issue-with-CMake-3.10-leadig.patch

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 27 Mar 2018 09:53:40 +0200

dune-uggrid (2.5.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright: Upgrade copyright format URL to https://.
  * Bumped Standards-Version to 4.0.0.

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 18 Jul 2017 12:04:21 +0200

dune-uggrid (2.5.1~rc1-1) experimental; urgency=medium

  * New upstream release candidate.
  * No longer build manual -dbg package. Use the automatically generated
    -dbgsym package instead.

 -- Ansgar Burchardt <ansgar@debian.org>  Sat, 17 Jun 2017 16:15:42 +0200

=== debian/control ===
Source: dune-uggrid
Section: libs
Priority: optional
Standards-Version: 4.0.0
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-uggrid.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-uggrid.git
Homepage: https://gitlab.dune-project.org/staging/dune-uggrid/
Build-Depends: debhelper (>= 9),
 cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
 libdune-common-dev (>= 2.5.1)

Package: libdune-uggrid-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
 libdune-common-dev (>= 2.5.1)
Provides: ${dune:shared-library}
Conflicts: libug-dev
Replaces: libug-dev
Description: software framework for finite element methods (development files)
 UG is a flexible software tool for the numerical solution of partial
 differential equations on unstructured meshes, with a focus on
 multigrid methods. It has a very powerful grid manager, which supports
 two- and three-dimensional grids with mixed element types. The grids
 can be adaptively refinement using either classic
 red/green-refinement, or pure red refinement with hanging nodes. All
 this is fully parallelized and can run on large distributed machines.
 .
 The version in this package has been built with the necessary flags for use
 with the Dune software system.
 .
 This package contains the development files.

## dune-uggrid 2.6.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,15 @@
 # general stuff
 cmake_minimum_required(VERSION 2.8.12)
 
+# Guess the dune-common build directory if it is not yet set
+if(NOT (dune-common_DIR OR dune-common_ROOT OR
+      "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
+  string(REPLACE  ${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
+    ${PROJECT_BINARY_DIR})
+endif()
+
 #find dune-common and set the module path
-find_package(dune-common)
+find_package(dune-common REQUIRED)
 list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
      "${CMAKE_SOURCE_DIR}/cmake/modules")# make sure our own modules are found
 
@@ -43,8 +50,8 @@
   set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DDebug")
 endif()
 
-add_definitions(-DUGLIB -DFOR_DUNE)
-set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DUGLIB -DFOR_DUNE")
+add_definitions(-DUGLIB)
+set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DUGLIB")
 
 #Always build parallel libs if MPI is found
 if(UG_ENABLE_PARALLEL)
@@ -57,7 +64,7 @@
 
 #set the include headers
 include_directories(${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/low
-  ${PROJECT_SOURCE_DIR}/gm ${PROJECT_SOURCE_DIR}/dev ${PROJECT_SOURCE_DIR}/dom
+  ${PROJECT_SOURCE_DIR}/gm ${PROJECT_SOURCE_DIR}/dom
   ${PROJECT_SOURCE_DIR}/np ${PROJECT_SOURCE_DIR}/ui
   ${PROJECT_SOURCE_DIR}/np/algebra
   ${PROJECT_SOURCE_DIR}/np/udm
@@ -162,7 +169,6 @@
 else()
   set(parallel "no")
 endif()
-set(fordune "yes")
 set(VERSION ${DUNE_UGGRID_VERSION})
 configure_file(libug.pc.in libug.pc)
 configure_file(ug-config.cmake.in ug-config.cmake @ONLY)

=== dev/CMakeLists.txt ===
set(SOURCES  ugdevices.cc)
set(devinclude_HEADERS  ugdevices.h)

add_library(devices OBJECT ${SOURCES})
install(FILES ${devinclude_HEADERS} DESTINATION  ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== dom/CMakeLists.txt ===
# compile the different domain-modules
add_subdirectory(std)
# install the central header
install(FILES domain.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== gm/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 set(SOURCES  algebra.cc enrol.cc evm.cc mgio.cc
   ugio.cc ugm.cc cw.cc initgm.cc elements.cc
-  shapes.cc evalproc.cc rm.cc refine.cc smooth.cc
+  shapes.cc evalproc.cc rm.cc refine.cc
   dlmgr.cc gmcheck.cc er.cc mgheapmgr.cc)
 # put this "template" into distribution-tarball as well
 set(EXTRA_DIST  dlmgr.t)

=== lib/CMakeLists.txt ===
add_subdirectory(ugdata)

if(UG_ENABLE_PARALLEL)
  set(_parallel_dim_libs parallel ddd analyser basic ctrl ident if join mgr prio xfer dddif)
  set(_parallel_libs ppifmpi parutil)
endif()

set(_dim_libs ug_gm np algebra udm ugui)

foreach(_l ${_parallel_libs})
  list(APPEND _parallel_objs $<TARGET_OBJECTS:${_l}>)
endforeach()

dune_add_library(ugL $<TARGET_OBJECTS:devices> $<TARGET_OBJECTS:low> ${_parallel_objs})
ug_add_dim_libs(ugS APPEND DUNE SOURCES ../initug.cc
  OBJECT_DIM_LIBS ${_dim_libs} domS ${_parallel_dim_libs}
  ADD_LIBS ugL
  )

if(MPI_C_FOUND)
  add_dune_mpi_flags(ugL)
  add_dune_mpi_flags(ugS2 ugS3)
endif()

=== low/CMakeLists.txt ===
add_subdirectory(test)

# normal headers
set(lowinclude_HEADERS  heaps.h ugenv.h ugstruct.h misc.h debug.h ugtypes.h
  general.h dimension.h ugtimer.h scan.h
  defaults.h fileopen.h namespace.h)

# dimension-independent lib
add_library(low OBJECT ugenv.cc heaps.cc fifo.cc misc.cc defaults.cc initlow.cc
  fileopen.cc ugstruct.cc debug.cc bio.cc scan.cc ugtimer.cc)

if(DUNE_BUILD_BOTH_LIBS)
  # For shared libraries we need position independent code
  set_property(TARGET low PROPERTY POSITION_INDEPENDENT_CODE TRUE)
endif()

install(FILES ${lowinclude_HEADERS} DESTINATION  ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== np/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(SOURCES  initnp.cc)# initnp.h initnumerics.h np.h)
+set(SOURCES  initnp.cc)# initnumerics.h np.h)
 
 add_subdirectory(algebra)
 add_subdirectory(udm)

=== parallel/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
   # Maybe dune-common should export them?
   add_definitions(-DENABLE_MPI=1 -DMPICH_SKIP_MPICXX -DMPIPP_H)
   include_directories("${MPI_DUNE_INCLUDE_PATH}")
-  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS ${MPI_DUNE_COMPILE_FLAGS})
+  set_property(DIRECTORY APPEND PROPERTY COMPILE_OPTIONS "${MPI_DUNE_COMPILE_FLAGS}")
  ug_add_dim_libs(parallel OBJECT initparallel.cc) # OBJECT_DIM_LIBS ddd dddif)
 endif()

=== ui/CMakeLists.txt ===
install(FILES commands.h
  DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})
ug_add_dim_libs(ugui OBJECT SOURCES commands.cc)

=== cmake/modules/CMakeLists.txt ===
install(FILES DuneUggridMacros.cmake DESTINATION ${DUNE_INSTALL_MODULEDIR})

=== dom/gen/CMakeLists.txt ===
ug_add_dim_libs(domG OBJECT SOURCES gen.c gen_parallel.c)

=== dom/std/CMakeLists.txt ===
set(SOURCES  std_domain.cc std_parallel.cc) # std_domain.h std_internal.h)
ug_add_dim_libs(domS OBJECT SOURCES ${SOURCES})
install(FILES std_domain.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})

=== debian/changelog ===
dune-uggrid (2.6.0-1build3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:13:18 +0100

dune-uggrid (2.6.0-1build2) cosmic; urgency=medium

  * No-change rebuild for libgfortran soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 12:25:25 +0000

dune-uggrid (2.6.0-1build1) cosmic; urgency=medium

  * No-change rebuild for openmpi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 May 2018 21:53:33 +0000

dune-uggrid (2.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Ansgar Burchardt <ansgar@debian.org>  Tue, 03 Apr 2018 22:42:23 +0200

dune-uggrid (2.6~20180108-1) experimental; urgency=medium

  * New upstream snapshot (commit: b30bd26b596a7298f4c5d9fcdde4209f630483d4)
  * d/control: update Vcs-* fields for move to salsa.debian.org
  * Bumped Standards-Version to 4.1.3.

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 08 Jan 2018 11:41:48 +0100

dune-uggrid (2.6~20171120-1) experimental; urgency=medium

  * New upstream snapshot (commit: 233efec13770d21ed952438ae78c6e80fa9fff69)
  * Bumped Standards-Version to 4.1.1 (no changes).

 -- Ansgar Burchardt <ansgar@debian.org>  Mon, 20 Nov 2017 22:41:31 +0100

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk

%:
	dh $@ --parallel --builddirectory=build

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## dune-uggrid 2.7.0

=== debian/changelog ===
dune-uggrid (2.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ansgar <ansgar@debian.org>  Wed, 15 Jul 2020 12:36:31 +0200

dune-uggrid (2.7.0-1) experimental; urgency=medium

  * New upstream release.
  * Use debhelper compat level 13.
  * Bumped Standards-Version to 4.5.0 (no changes).

 -- Ansgar <ansgar@debian.org>  Mon, 25 May 2020 16:15:34 +0200

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,23 @@
 Source: dune-uggrid
 Section: libs
 Priority: optional
-Standards-Version: 4.0.0
+Standards-Version: 4.5.0
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Ansgar Burchardt <ansgar@debian.org>, Oliver Sander <sander@mi.fu-berlin.de>
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/dune-uggrid.git
-Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/dune-uggrid.git
+Uploaders: Ansgar <ansgar@debian.org>
+Vcs-Browser: https://salsa.debian.org/science-team/dune-uggrid
+Vcs-Git: https://salsa.debian.org/science-team/dune-uggrid.git
 Homepage: https://gitlab.dune-project.org/staging/dune-uggrid/
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper-compat (= 13),
  cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
- libdune-common-dev (>= 2.5.1)
+ libdune-common-dev (>= 2.7.0-3)
+Rules-Requires-Root: no
 
 Package: libdune-uggrid-dev
 Section: libdevel
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends},
- libdune-common-dev (>= 2.5.1)
+ libdune-common-dev (>= 2.7.0-3)
 Provides: ${dune:shared-library}
 Conflicts: libug-dev
 Replaces: libug-dev

## dune-uggrid 2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(BUILD_DOCS 1)
 
 # general stuff
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.1)
 
 # Guess the dune-common build directory if it is not yet set
 if(NOT (dune-common_DIR OR dune-common_ROOT OR
@@ -29,22 +29,25 @@
 # set defines that are only used internally.
 # The rest is in cmake/modules/DuneUggrid.cmake
 if(MPI_C_FOUND)
-  set(UG_ENABLE_PARALLEL True CACHE BOOL "Enable a parallel UG (default is True if MPI is there false otherwise")
+  set(UG_ENABLE_PARALLEL True CACHE BOOL "Enable a parallel UG (default is True if MPI is there False otherwise)")
 else()
-  set(UG_ENABLE_PARALLEL False CACHE BOOL "Enable a parallel UG (default is True if MPI is there false otherwise")
+  set(UG_ENABLE_PARALLEL False CACHE BOOL "Enable a parallel UG (default is True if MPI is there False otherwise)")
 endif()
 
 set(UG_ENABLE_DEBUGGING False CACHE BOOL "Enable UG debugging (default is Off)")
 set(UG_ENABLE_2D True CACHE BOOL "Build library for 2d (default is On)")
 set(UG_ENABLE_3D True CACHE BOOL "Build library for 3d (default is On)")
-set(UG_ENABLE_SYSTEM_HEAP ON CACHE BOOL "If ON/True then we are using the operating system heap instead of the one internal to UG (Default: ON")
+set(UG_ENABLE_SYSTEM_HEAP ON CACHE BOOL "If ON/True then we are using the operating system heap instead of the one internal to UG (Default: ON)")
 set(UG_DDD_MAX_MACROBITS "24" CACHE STRING
   "Set number of bits of an unsigned int used to store the process number,
        the remaining bits are used to store the local entity id")
-if(UG_ENABLE_SYSTEM_HEAP)
-  add_definitions("-DUG_USE_SYSTEM_HEAP=1")
-  set(UG_EXTRAFLAGS "-DUG_USE_SYSTEM_HEAP=1")
+
+set(DUNE_UGGRID_TET_RULESET True CACHE BOOL "Use complete rule set for refinement of tetrahedral elements")
+if(TET_RULESET)
+  set(DUNE_UGGRID_TET_RULESET True)
+  message(DEPRECATION "The TET_RULESET option has been renamed to DUNE_UGGRID_TET_RULESET")
 endif()
+
 if(UG_ENABLE_DEBUGGING)
   add_definitions("-DDebug")
   set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DDebug")
@@ -61,18 +64,6 @@
   add_definitions("-DModelP")
   set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DModelP")
 endif()
-
-#set the include headers
-include_directories(${PROJECT_SOURCE_DIR} ${PROJECT_SOURCE_DIR}/low
-  ${PROJECT_SOURCE_DIR}/gm ${PROJECT_SOURCE_DIR}/dom
-  ${PROJECT_SOURCE_DIR}/np ${PROJECT_SOURCE_DIR}/ui
-  ${PROJECT_SOURCE_DIR}/np/algebra
-  ${PROJECT_SOURCE_DIR}/np/udm
-  ${PROJECT_SOURCE_DIR}/parallel ${PROJECT_SOURCE_DIR}/parallel/ddd
-  ${PROJECT_SOURCE_DIR}/parallel/ppif
-  ${PROJECT_SOURCE_DIR}/parallel/dddif ${PROJECT_SOURCE_DIR}/parallel/util
-  ${PROJECT_SOURCE_DIR}/parallel/ddd/include )
-
 
 set(UG_ENABLED_DIMENSIONS)
 if(UG_ENABLE_2D)
@@ -135,6 +126,11 @@
     endif()
     foreach(_lib ${_libs})
       target_compile_definitions("${_lib}" PRIVATE "-DUG_DIM_${dim}")
+      if(OBJECT)
+        add_dune_mpi_flags("${_lib}" OBJECT)
+      else()
+        add_dune_mpi_flags("${_lib}")
+      endif()
     endforeach()
     set(_append "APPEND") # Do not overwrite but append next lib in export
   endforeach()
@@ -149,51 +145,13 @@
   set(TIME_WITH_SYS_TIME True)
 endif()
 
-# do everything in the subdirs (order matters because of library dependencies!)
-if(UG_ENABLE_PARALLEL)
-  set(SUBDIRS  parallel)
-else()
-  set(SUBDIRS "")
-endif()
-set(SUBDIRS  ${SUBDIRS} low dev gm dom np ui lib)
-set(CMAKE_INSTALL_PKGINCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/ug")
-
-# create and install pkg-config information and
-# cmake package configuration as ug not dune-uggrid
-set(prefix ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix "\${prefix}")
-set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
-set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
-if(UG_ENABLE_PARALLEL)
-  set(parallel "yes")
-else()
-  set(parallel "no")
-endif()
-set(VERSION ${DUNE_UGGRID_VERSION})
-configure_file(libug.pc.in libug.pc)
-configure_file(ug-config.cmake.in ug-config.cmake @ONLY)
-configure_file(ug-config-version.cmake.in ug-config-version.cmake @ONLY)
-
-#install header
-install(FILES initug.h DESTINATION ${CMAKE_INSTALL_PKGINCLUDEDIR})
-foreach(i ${SUBDIRS})
-  add_subdirectory(${i})
-endforeach(i ${SUBDIRS})
-
+add_subdirectory(dune)
 add_subdirectory(cmake/modules)
 # set variable names for config.h
 set(DDD_MAX_PROCBITS_IN_GID ${UG_DDD_MACROBITS})
 # finalize the dune project, e.g., generate config.h etc.
 # Use package init to set additional information
-set(dune-uggrid_INIT "set(UG_PARALLEL ${parallel})
+set(dune-uggrid_INIT "set(UG_PARALLEL ${UG_ENABLE_PARALLEL})
 set(UG_FOR_DUNE yes)")
 
 finalize_dune_project(GENERATE_CONFIG_H_CMAKE)
-
-# This comes after finalize as it uses DUNE_INSTALL_LIBDIR
-# computed there.
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libug.pc
-  DESTINATION ${DUNE_INSTALL_LIBDIR}/pkgconfig)
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ug-config.cmake
-  ${CMAKE_CURRENT_BINARY_DIR}/ug-config-version.cmake
-  DESTINATION ${DUNE_INSTALL_LIBDIR}/cmake/ug)

=== dune/uggrid/CMakeLists.txt ===
add_subdirectory(domain)
add_subdirectory(gm)
add_subdirectory(lib)
add_subdirectory(low)
add_subdirectory(numerics)
add_subdirectory(parallel)

install(
  FILES ugdevices.h commands.h initug.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid)

add_library(devices OBJECT ugdevices.cc)
ug_add_dim_libs(ugui OBJECT ugdevices.cc commands.cc)

=== dune/uggrid/domain/CMakeLists.txt ===
ug_add_dim_libs(domS OBJECT
  SOURCES
  std_domain.cc
  std_parallel.cc)

install(FILES
  domain.h
  std_domain.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/domain)

=== dune/uggrid/gm/CMakeLists.txt ===
set(SOURCES  algebra.cc enrol.cc evm.cc mgio.cc
  ugio.cc ugm.cc cw.cc initgm.cc elements.cc
  shapes.cc evalproc.cc rm.cc refine.cc
  dlmgr.cc gmcheck.cc er.cc mgheapmgr.cc rm-write2file.cc )
# put this "template" into distribution-tarball as well
set(EXTRA_DIST  dlmgr.t)

ug_add_dim_libs(ug_gm OBJECT SOURCES ${SOURCES})# OBJECT_DIM_LIBS gg)

dune_add_test(
  NAME rm3-tetrahedron-rules-test
  SOURCES rm-tetrahedron-rules-test.cc
  COMPILE_DEFINITIONS -DUG_DIM_3
  LINK_LIBRARIES ugL ugS3 ${DUNE_LIBS}
  CMAKE_GUARD DUNE_UGGRID_TET_RULESET
  )

# rm3-show
add_executable(rm3-show rm-show.cc)
target_compile_definitions(rm3-show PRIVATE -DUG_DIM_3)
target_link_libraries(rm3-show PRIVATE ugL ugS3 ${DUNE_LIBS})

# rm3-writeRefRules2file
add_executable(rm3-writeRefRules2file rm-writeRefRules2file.cc rm-write2file.h rm-write2file.cc)
target_compile_definitions(rm3-writeRefRules2file PRIVATE -DUG_DIM_3)
target_link_libraries(rm3-writeRefRules2file PRIVATE ugL ugS3 ${DUNE_LIBS})

install(FILES
  algebra.h
  cw.h
  dlmgr.h
  elements.h
  evm.h
  gm.h
  pargm.h
  refine.h
  rm.h
  rm-write2file.h
  shapes.h
  ugm.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/gm)

=== dune/uggrid/lib/CMakeLists.txt ===
if(UG_ENABLE_PARALLEL)
  set(_parallel_dim_libs ddd analyser ctrl ident if join mgr prio xfer dddif)
  set(_parallel_libs basic ppifmpi)
endif()

set(_dim_libs numerics ug_gm ugui)

foreach(_l ${_parallel_libs})
  list(APPEND _parallel_objs $<TARGET_OBJECTS:${_l}>)
endforeach()

dune_add_library(ugL $<TARGET_OBJECTS:devices> $<TARGET_OBJECTS:low> ${_parallel_objs}
  SOURCES
  ../parallel/ddd/dddcontext.cc
  ../parallel/ppif/ppifcontext.cc
  ADD_LIBS ${DUNE_LIBS}
  )
ug_add_dim_libs(ugS APPEND DUNE SOURCES ../initug.cc
  OBJECT_DIM_LIBS ${_dim_libs} domS ${_parallel_dim_libs}
  ADD_LIBS ugL ${DUNE_LIBS}
  )

if(MPI_C_FOUND)
  add_dune_mpi_flags(ugL)
endif()

install(
  FILES RefRules.data tetra.rls triangle.rls
  DESTINATION ${CMAKE_INSTALL_DATADIR})

=== dune/uggrid/low/CMakeLists.txt ===
add_subdirectory(test)

# dimension-independent lib
add_library(low OBJECT ugenv.cc heaps.cc fifo.cc misc.cc defaults.cc initlow.cc
  fileopen.cc ugstruct.cc debug.cc bio.cc scan.cc ugtimer.cc)

if(DUNE_BUILD_BOTH_LIBS)
  # For shared libraries we need position independent code
  set_property(TARGET low PROPERTY POSITION_INDEPENDENT_CODE TRUE)
endif()

install(FILES
  debug.h
  defaults.h
  dimension.h
  fileopen.h
  general.h
  heaps.h
  misc.h
  namespace.h
  scan.h
  ugenv.h
  ugstruct.h
  ugtimer.h
  ugtypes.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/low)

=== dune/uggrid/numerics/CMakeLists.txt ===
ug_add_dim_libs(numerics OBJECT SOURCES initnp.cc sm.cc disctools.cc formats.cc udm.cc)

install(FILES
  disctools.h
  formats.h
  np.h
  sm.h
  udm.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/numerics)

=== dune/uggrid/low/test/CMakeLists.txt ===
dune_add_test(SOURCES test-fifo.cc)
target_link_libraries(test-fifo ugL)

=== dune/uggrid/parallel/ddd/CMakeLists.txt ===
add_subdirectory(include)

install(FILES
  dddconstants.hh
  dddcontext.hh
  dddtypes.hh
  dddtypes_impl.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/ddd)

if(UG_ENABLE_PARALLEL)
  add_subdirectory(analyser)
  add_subdirectory(basic)
  add_subdirectory(ctrl)
  add_subdirectory(ident)
  add_subdirectory(if)
  add_subdirectory(join)
  add_subdirectory(mgr)
  add_subdirectory(prio)
  add_subdirectory(xfer)

  if(HAVE_MPI)
    ug_add_dim_libs(ddd OBJECT ddd.cc)
  endif()
endif()

=== dune/uggrid/parallel/dddif/CMakeLists.txt ===
install(FILES parallel.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/dddif/)

if(MPI_C_FOUND)
  include_directories(${PROJECT_SOURCE_DIR}/dune/uggrid/parallel/ddd/include)
  ug_add_dim_libs(dddif OBJECT
    SOURCES
    compat.cc
    debugger.cc
    gridcons.cc
    handler.cc
    identify.cc
    identify.h
    initddd.cc
    lb.cc
    lbrcb.cc
    memmgr.cc
    overlap.cc
    priority.cc
    pgmcheck.cc
    partition.cc
    support.cc
    trans.cc
    )
endif()

=== dune/uggrid/parallel/ppif/CMakeLists.txt ===
install(FILES
  ppif.h
  ppifcontext.hh
  ppiftypes.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/ppif)

if(UG_ENABLE_PARALLEL)
  if(MPI_C_FOUND)
    add_library(ppifmpi OBJECT ppif.cc)
    add_dune_mpi_flags(ppifmpi OBJECT)
    if(DUNE_BUILD_BOTH_LIBS)
      # For shared libraries we need position independent code
      set_property(TARGET ppifmpi PROPERTY POSITION_INDEPENDENT_CODE TRUE)
    endif()
  endif()
endif()

=== dune/uggrid/parallel/ddd/basic/CMakeLists.txt ===
add_subdirectory(test)

if(MPI_C_FOUND)
  add_library(basic OBJECT io.cc lowcomm.cc notify.cc reduct.cc topo.cc)
  add_dune_mpi_flags(basic OBJECT)
endif()

install(FILES notify.h lowcomm.h oopp.h ooppcc.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/ddd/basic)

=== debian/changelog ===
dune-uggrid (2.7.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Ansgar <ansgar@debian.org>  Mon, 11 Jan 2021 22:32:52 +0100

dune-uggrid (2.7.1-1) experimental; urgency=medium

  * New upstream release

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Thu, 07 Jan 2021 10:15:21 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Homepage: https://gitlab.dune-project.org/staging/dune-uggrid/
 Build-Depends: debhelper-compat (= 13),
  cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
- libdune-common-dev (>= 2.7.0-3)
+ libdune-common-dev (>= 2.7.1)
 Rules-Requires-Root: no
 
 Package: libdune-uggrid-dev
@@ -17,7 +17,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends},
- libdune-common-dev (>= 2.7.0-3)
+ libdune-common-dev (>= 2.7.1)
 Provides: ${dune:shared-library}
 Conflicts: libug-dev
 Replaces: libug-dev

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk

%:
	dh $@ --builddirectory=build

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## dune-uggrid 2.8.0

=== CMakeLists.txt ===
# set up project
project("dune-uggrid" C CXX)

#circumvent not building docs
set(BUILD_DOCS 1)

# general stuff
cmake_minimum_required(VERSION 3.13)

# Guess the dune-common build directory if it is not yet set
if(NOT (dune-common_DIR OR dune-common_ROOT OR
      "${CMAKE_PREFIX_PATH}" MATCHES ".*dune-common.*"))
  string(REPLACE  ${CMAKE_PROJECT_NAME} dune-common dune-common_DIR
    ${PROJECT_BINARY_DIR})
endif()

#find dune-common and set the module path
find_package(dune-common REQUIRED)
list(APPEND CMAKE_MODULE_PATH ${dune-common_MODULE_PATH}
     "${CMAKE_SOURCE_DIR}/cmake/modules")# make sure our own modules are found

#include the dune macros
include(DuneMacros)

# start a dune project with information from dune.module
dune_project()

find_package(MPI)
# set defines that are only used internally.
# The rest is in cmake/modules/DuneUggrid.cmake
if(MPI_C_FOUND)
  set(UG_ENABLE_PARALLEL True CACHE BOOL "Enable a parallel UG (default is True if MPI is there False otherwise)")
else()
  set(UG_ENABLE_PARALLEL False CACHE BOOL "Enable a parallel UG (default is True if MPI is there False otherwise)")
endif()

set(UG_ENABLE_DEBUGGING False CACHE BOOL "Enable UG debugging (default is Off)")
set(UG_ENABLE_SYSTEM_HEAP ON CACHE BOOL "If ON/True then we are using the operating system heap instead of the one internal to UG (Default: ON)")
set(UG_DDD_MAX_MACROBITS "24" CACHE STRING
  "Set number of bits of an unsigned int used to store the process number,
       the remaining bits are used to store the local entity id")

set(DUNE_UGGRID_TET_RULESET True CACHE BOOL "Use complete rule set for refinement of tetrahedral elements")
if(TET_RULESET)
  set(DUNE_UGGRID_TET_RULESET True)
  message(DEPRECATION "The TET_RULESET option has been renamed to DUNE_UGGRID_TET_RULESET")
endif()

if(UG_ENABLE_DEBUGGING)
  list(APPEND UG_COMPILE_DEFINITIONS "Debug")
  set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DDebug")
endif()

#Always build parallel libs if MPI is found
if(UG_ENABLE_PARALLEL)
  if(NOT MPI_C_FOUND)
    message(SEND_ERROR "A parallel UG was requested but MPI was not found. Either change variable UG_ENABLE_PARALLEL or install MPI." )
  endif()
  list(APPEND UG_COMPILE_DEFINITIONS "ModelP")
  set(UG_EXTRAFLAGS "${UG_EXTRAFLAGS} -DModelP")
endif()

# define target for duneuggrid
dune_add_library(duneuggrid)
target_compile_definitions(duneuggrid PUBLIC ${UG_COMPILE_DEFINITIONS})
add_dune_mpi_flags(duneuggrid)

check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(time.h HAVE_TIME_H)

if(HAVE_TIME_H AND HAVE_SYS_TIME_H)
  set(TIME_WITH_SYS_TIME True)
endif()

add_subdirectory(dune)
add_subdirectory(cmake/modules)
# set variable names for config.h
set(DDD_MAX_PROCBITS_IN_GID ${UG_DDD_MACROBITS})
# finalize the dune project, e.g., generate config.h etc.
# Use package init to set additional information
set(dune-uggrid_INIT "set(UG_PARALLEL ${UG_ENABLE_PARALLEL})")

finalize_dune_project(GENERATE_CONFIG_H_CMAKE)

=== dune/CMakeLists.txt ===
add_subdirectory(uggrid)

=== dune/uggrid/CMakeLists.txt ===
set(UG_ENABLED_DIMENSIONS 2 3)

# define dimension specific object libraries
foreach(dim ${UG_ENABLED_DIMENSIONS})
  add_library(duneuggrid${dim}d OBJECT)
  target_compile_definitions(duneuggrid${dim}d PRIVATE "UG_DIM_${dim}")
  target_compile_definitions(duneuggrid${dim}d PRIVATE ${UG_COMPILE_DEFINITIONS})
  add_dune_mpi_flags(duneuggrid${dim}d OBJECT)

  # register dimension-dependent objects in duneuggrid library
  target_sources(duneuggrid PRIVATE $<TARGET_OBJECTS:duneuggrid${dim}d>)
endforeach()

# macro that adds sources to all dimension-targets `${target}${dim}d`,
# see UG_ENABLED_DIMENSIONS
macro(target_sources_dims target)
  foreach(dim ${UG_ENABLED_DIMENSIONS})
    target_sources(${target}${dim}d ${ARGN})
  endforeach(dim)
endmacro()


target_sources(duneuggrid PRIVATE
  ugdevices.cc)

target_sources_dims(duneuggrid PRIVATE
  initug.cc)

install(
  FILES ugdevices.h initug.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid)

add_subdirectory(domain)
add_subdirectory(gm)
add_subdirectory(lib)
add_subdirectory(low)
add_subdirectory(parallel)

=== dune/uggrid/domain/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
-ug_add_dim_libs(domS OBJECT
-  SOURCES
+target_sources_dims(duneuggrid PRIVATE
   std_domain.cc
   std_parallel.cc)

=== dune/uggrid/gm/CMakeLists.txt ===
target_sources_dims(duneuggrid PRIVATE
  algebra.cc
  cw.cc
  dlmgr.cc
  elements.cc
  enrol.cc
  er.cc
  evm.cc
  gmcheck.cc
  initgm.cc
  mgheapmgr.cc
  mgio.cc
  refine.cc
  rm-write2file.cc
  rm.cc
  shapes.cc
  ugio.cc
  ugm.cc)

dune_add_test(
  NAME rm3-tetrahedron-rules-test
  SOURCES rm-tetrahedron-rules-test.cc
  COMPILE_DEFINITIONS -DUG_DIM_3
  LINK_LIBRARIES duneuggrid ${DUNE_LIBS}
  CMAKE_GUARD DUNE_UGGRID_TET_RULESET
  )

# rm3-show
add_executable(rm3-show rm-show.cc)
target_compile_definitions(rm3-show PRIVATE -DUG_DIM_3)
target_link_libraries(rm3-show PRIVATE duneuggrid ${DUNE_LIBS})

# rm3-writeRefRules2file
add_executable(rm3-writeRefRules2file rm-writeRefRules2file.cc rm-write2file.h rm-write2file.cc)
target_compile_definitions(rm3-writeRefRules2file PRIVATE -DUG_DIM_3)
target_link_libraries(rm3-writeRefRules2file PRIVATE duneuggrid ${DUNE_LIBS})

install(FILES
  algebra.h
  cw.h
  dlmgr.h
  elements.h
  evm.h
  gm.h
  pargm.h
  refine.h
  rm-write2file.h
  rm.h
  shapes.h
  ugm.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/gm)

=== dune/uggrid/lib/CMakeLists.txt ===
install(
  FILES RefRules.data tetra.rls triangle.rls
  DESTINATION ${CMAKE_INSTALL_DATADIR})

=== dune/uggrid/low/CMakeLists.txt ===
add_subdirectory(test)

target_sources(duneuggrid PRIVATE
  bio.cc
  debug.cc
  fifo.cc
  fileopen.cc
  heaps.cc
  initlow.cc
  misc.cc
  scan.cc
  ugenv.cc
  ugstruct.cc
  ugtimer.cc)

install(FILES
  debug.h
  dimension.h
  fileopen.h
  heaps.h
  misc.h
  namespace.h
  scan.h
  ugenv.h
  ugstruct.h
  ugtimer.h
  ugtypes.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/low)

=== dune/uggrid/parallel/CMakeLists.txt ===
add_subdirectory(ddd)
add_subdirectory(ppif)

if(UG_ENABLE_PARALLEL)
  add_subdirectory(dddif)
endif()

=== dune/uggrid/low/test/CMakeLists.txt ===
dune_add_test(SOURCES test-fifo.cc
              LINK_LIBRARIES duneuggrid)

=== dune/uggrid/parallel/ddd/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
   add_subdirectory(prio)
   add_subdirectory(xfer)
 
-  if(HAVE_MPI)
-    ug_add_dim_libs(ddd OBJECT ddd.cc)
-  endif()
+  target_sources_dims(duneuggrid PRIVATE ddd.cc)
 endif()
+
+target_sources(duneuggrid PRIVATE dddcontext.cc)

=== dune/uggrid/parallel/dddif/CMakeLists.txt ===
target_sources_dims(duneuggrid PRIVATE
  compat.cc
  debugger.cc
  gridcons.cc
  handler.cc
  identify.cc
  identify.h
  initddd.cc
  lb.cc
  lbrcb.cc
  memmgr.cc
  overlap.cc
  partition.cc
  pgmcheck.cc
  priority.cc
  support.cc
  trans.cc)

install(FILES parallel.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/dddif/)

=== dune/uggrid/parallel/ppif/CMakeLists.txt ===
if(UG_ENABLE_PARALLEL)
  target_sources(duneuggrid PRIVATE ppif.cc)
endif()

target_sources(duneuggrid PRIVATE ppifcontext.cc)

install(FILES
  ppif.h
  ppifcontext.hh
  ppiftypes.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dune/uggrid/parallel/ppif)

=== debian/changelog ===
dune-uggrid (2.8.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Thu, 21 Oct 2021 18:45:48 +0200

dune-uggrid (2.8.0-1) experimental; urgency=medium

  * New upstream release.

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Wed, 15 Sep 2021 11:28:40 +0200

dune-uggrid (2.8.0~rc1-1) experimental; urgency=medium

  * New upstream release.
  * debian/rules: Explicitly set buildsystem to CMake

 -- Patrick Jaap <patrick.jaap@tu-dresden.de>  Mon, 23 Aug 2021 07:24:38 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Homepage: https://gitlab.dune-project.org/staging/dune-uggrid/
 Build-Depends: debhelper-compat (= 13),
  cmake, gfortran, mpi-default-bin, mpi-default-dev, pkg-config, python3,
- libdune-common-dev (>= 2.7.1)
+ libdune-common-dev (>= 2.8.0)
 Rules-Requires-Root: no
 
 Package: libdune-uggrid-dev
@@ -17,7 +17,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends},
- libdune-common-dev (>= 2.7.1)
+ libdune-common-dev (>= 2.8.0)
 Provides: ${dune:shared-library}
 Conflicts: libug-dev
 Replaces: libug-dev

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dune/dune-debian.mk

%:
	dh $@ --builddirectory=build --buildsystem=cmake

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp
